#ifndef __ASM_ARCH_BENZINA2_H
#define __ASM_ARCH_BENZINA2_H
//Lincoln: TODO: Check HW spec to correct the OLED pins setting.
//NOTE: the OLED pins name is LCDxxx in HW spec

#include <mach/mfp.h>

#define VOLUME_UP_KEY			MFP_CFG_X(GPIO0, AF0, DS01X, PULL_HIGH)
#define VOLUME_DOWN_KEY			MFP_CFG_X(GPIO1, AF0, DS01X, PULL_HIGH)
#define OPTION_KEY			MFP_CFG_X(GPIO2, AF0, DS01X, PULL_HIGH)
#define VR_KEY				MFP_CFG_X(GPIO3, AF0, DS01X, PULL_HIGH)
#define CAM_ON_KEY			MFP_CFG_X(GPIO4, AF0, DS01X, PULL_HIGH)
#define MOT_INT				MFP_CFG_X(GPIO5, AF0, DS01X, FLOAT)
#define CAM_SHOT_KEY			MFP_CFG_X(GPIO6, AF0, DS01X, PULL_HIGH)
#define AUDIO_AMP_PM_EN			MFP_CFG_X(GPIO7, AF0, DS01X, FLOAT)
#define GPIO8_FREE			MFP_CFG_X(GPIO8, AF0, DS01X, PULL_LOW_SEL)
#define CPS_RSTN			MFP_CFG_LPM(GPIO9, AF0, DRIVE_LOW)
#define CPS_INT				MFP_CFG_X(GPIO10, AF0, DS01X, PULL_HIGH)
#define WLAN_PD_GH381			MFP_CFG_X(GPIO11, AF0, DS01X, DRIVE_LOW)
#define WLAN_PD_GH381_LPM_ON		MFP_CFG_X(GPIO11, AF0, DS01X, DRIVE_HIGH)
#define OLED_SPI_CLK			MFP_CFG_X(GPIO12, AF3, DS03X, PULL_LOW)
#define OLED_SPI_CS			MFP_CFG_X(GPIO13, AF3, DS03X, PULL_LOW)
#define TAVOR_WAKEUP_BT			MFP_CFG_LPM(GPIO14, AF0, DRIVE_LOW)
#define TAVOR_WAKEUP_BT_LPM_ON		MFP_CFG_LPM(GPIO14, AF0, DRIVE_HIGH)
#define OLED_SPI_DIN			MFP_CFG_X(GPIO15, AF3, DS03X, PULL_LOW)

#define TAVOR_ONE_WIRE			MFP_CFG_X(GPIO16, AF3, DS03X, PULL_HIGH)
#define OLED_VSYNC			MFP_CFG_X(GPIO17, AF1, DS03X, DRIVE_LOW)	
#define OLED_HSYNC			MFP_CFG_X(GPIO18, AF1, DS03X, DRIVE_LOW)
#define OLED_PCLK			MFP_CFG_X(GPIO19, AF1, DS03X, DRIVE_LOW)
#define OLED_RESET_N		MFP_CFG_X(GPIO20, AF0, DS03X, DRIVE_LOW)
#define OLED_DE				MFP_CFG_X(GPIO21, AF3, DS03X, DRIVE_LOW)
#define VCM_PD				MFP_CFG_X(GPIO22, AF0, DS02X, DRIVE_LOW)

#define OLED_D0 				MFP_CFG_X(GPIO23, AF1, DS03X, DRIVE_LOW)
#define OLED_D1				MFP_CFG_X(GPIO24, AF1, DS03X, DRIVE_LOW)
#define OLED_D2				MFP_CFG_X(GPIO25, AF1, DS03X, DRIVE_LOW)
#define OLED_D3				MFP_CFG_X(GPIO26, AF1, DS03X, DRIVE_LOW)
#define OLED_D4				MFP_CFG_X(GPIO27, AF1, DS03X, DRIVE_LOW)
#define OLED_D5				MFP_CFG_X(GPIO28, AF1, DS03X, DRIVE_LOW)
#define OLED_D6				MFP_CFG_X(GPIO29, AF1, DS03X, DRIVE_LOW)
#define OLED_D7				MFP_CFG_X(GPIO30, AF1, DS03X, DRIVE_LOW)
#define OLED_D8				MFP_CFG_X(GPIO31, AF1, DS03X, DRIVE_LOW)
#define OLED_D9				MFP_CFG_X(GPIO32, AF1, DS03X, DRIVE_LOW)
#define OLED_D10				MFP_CFG_X(GPIO33, AF1, DS03X, DRIVE_LOW)
#define OLED_D11				MFP_CFG_X(GPIO34, AF1, DS03X, DRIVE_LOW)
#define OLED_D12				MFP_CFG_X(GPIO35, AF1, DS03X, DRIVE_LOW)
#define OLED_D13				MFP_CFG_X(GPIO36, AF1, DS03X, DRIVE_LOW)
#define OLED_D14				MFP_CFG_X(GPIO37, AF1, DS03X, DRIVE_LOW)
#define OLED_D15				MFP_CFG_X(GPIO38, AF1, DS03X, DRIVE_LOW)
#define MMC0_CD				MFP_CFG_X(GPIO39, AF0, DS03X, FLOAT)
#define GPS_LNA_EN			MFP_CFG_X(GPIO40, AF0, DS03X, DRIVE_LOW)
#define OLED_D16				MFP_CFG_X(GPIO41, AF3, DS03X, DRIVE_LOW)
#define OLED_D17				MFP_CFG_X(GPIO42, AF3, DS03X, DRIVE_LOW)

#define GPIO43_FREE			MFP_CFG_X(GPIO43, AF0, DS03X, PULL_LOW_SEL)
#define HOME_KEY			MFP_CFG_X(GPIO44, AF0, DS03X, PULL_HIGH)
#define GPS_RX				MFP_CFG_X(GPIO45, AF3, DS02X, FLOAT)
#define GPS_TX				MFP_CFG_X(GPIO46, AF3, DS02X, DRIVE_HIGH)
#define TP_INT				MFP_CFG_X(GPIO47, AF0, DS02X, FLOAT)
#define PRO_INT				MFP_CFG_X(GPIO48, AF0, DS02X, FLOAT)
#define GPIO49_FREE			MFP_CFG_X(GPIO49, AF0, DS01X, PULL_LOW_SEL)
#define GPIO50_FREE			MFP_CFG_X(GPIO50, AF0, DS01X, PULL_LOW_SEL)
#define USB2UART_SEL			MFP_CFG_X(GPIO51, AF0, DS02X, FLOAT)
#define USB2UART_EN			MFP_CFG_X(GPIO52, AF0, DS02X, DRIVE_LOW)
#define FFRXD				MFP_CFG_X(GPIO53, AF1, DS02X, FLOAT)
#define FFTXD				MFP_CFG_X(GPIO54, AF1, DS02X, DRIVE_LOW)

#define MMC1_CMD			MFP_CFG_X(GPIO55, AF3, DS02X, DRIVE_LOW)
#define MMC1_CMD_ON			MFP_CFG_X(GPIO55, AF3, DS02X, PULL_HIGH)
#define MMC1_CLK			MFP_CFG_X(GPIO56, AF3, DS02X, DRIVE_LOW)
#define MMC1_CLK_ON			MFP_CFG_X(GPIO56, AF3, DS02X, FLOAT)
#define MMC1_DAT0			MFP_CFG_X(GPIO57, AF3, DS02X, DRIVE_LOW)
#define MMC1_DAT0_ON			MFP_CFG_X(GPIO57, AF3, DS02X, PULL_HIGH)
#define MMC1_DAT1			MFP_CFG_X(GPIO58, AF3, DS02X, DRIVE_LOW)
#define MMC1_DAT1_ON			MFP_CFG_X(GPIO58, AF3, DS02X, PULL_HIGH)
#define MMC1_DAT2			MFP_CFG_X(GPIO59, AF3, DS02X, DRIVE_LOW)
#define MMC1_DAT2_ON			MFP_CFG_X(GPIO59, AF3, DS02X, PULL_HIGH)
#define MMC1_DAT3			MFP_CFG_X(GPIO60, AF3, DS02X, DRIVE_LOW)
#define MMC1_DAT3_ON			MFP_CFG_X(GPIO60, AF3, DS02X, PULL_HIGH)

#define GPS_RESET			MFP_CFG_X(GPIO61, AF0, DS02X, DRIVE_HIGH)
#define GPIO62_FREE			MFP_CFG_X(GPIO62, AF0, DS01X, PULL_LOW_SEL)

#define PCM_CLK				MFP_CFG_LPM(GPIO63, AF2, PULL_LOW)
#define PCM_CLK_OFF			MFP_CFG_LPM(GPIO63, AF0, PULL_LOW)
#define PCM_SYNC			MFP_CFG_LPM(GPIO64, AF2, PULL_LOW)
#define PCM_SYNC_OFF			MFP_CFG_LPM(GPIO64, AF0, PULL_LOW)
#define PCM_TXD				MFP_CFG_LPM(GPIO65, AF2, PULL_LOW)
#define PCM_TXD_OFF			MFP_CFG_LPM(GPIO65, AF0, PULL_LOW)
#define PCM_RXD				MFP_CFG_LPM(GPIO66, AF2, PULL_LOW)
#define PCM_RXD_OFF			MFP_CFG_LPM(GPIO66, AF0, PULL_LOW)
#define GPIO67_FREE			MFP_CFG_LPM(GPIO67, AF0, PULL_LOW_SEL)
#define I2S_RXD				MFP_CFG_X(GPIO68, AF1, DS03X, PULL_LOW)
#define I2S_TXD				MFP_CFG_X(GPIO69, AF1, DS03X, PULL_LOW)
#define GPIO70_FREE			MFP_CFG_LPM(GPIO70, AF0, PULL_LOW_SEL)
#define I2S_SYNC			MFP_CFG_X(GPIO71, AF1, DS03X, PULL_LOW)
#define I2S_BITCLK			MFP_CFG_X(GPIO72, AF1, DS03X, PULL_LOW)
#define CI2C_SCL			MFP_CFG_LPM(GPIO73, AF1, FLOAT)
#define CI2C_SDA			MFP_CFG_LPM(GPIO74, AF1, FLOAT)
#define BT_UART_RXD			MFP_CFG_X(GPIO75, AF0, DS03X, DRIVE_LOW)
#define BT_UART_RXD_LPM_ON		MFP_CFG_X(GPIO75, AF1, DS03X, PULL_HIGH)
#define BT_UART_TXD			MFP_CFG_X(GPIO76, AF0, DS03X, DRIVE_LOW)
#define BT_UART_TXD_LPM_ON		MFP_CFG_X(GPIO76, AF1, DS03X, DRIVE_HIGH)
#define BT_UART_CTS			MFP_CFG_X(GPIO77, AF0, DS03X, DRIVE_LOW)
#define BT_UART_CTS_LPM_ON		MFP_CFG_X(GPIO77, AF1, DS03X, PULL_HIGH)
#define BT_UART_RTS			MFP_CFG_X(GPIO78, AF0, DS03X, DRIVE_LOW)
#define BT_UART_RTS_LPM_ON		MFP_CFG_X(GPIO78, AF1, DS03X, DRIVE_HIGH)
#define G2_HW_ID			MFP_CFG_X(GPIO79, AF0, DS01X, PULL_HIGH)
#define GPIO80_FREE			MFP_CFG_X(GPIO80, AF0, DS01X, PULL_LOW_SEL)
#define CAM_PD_MAIN			MFP_CFG_LPM(GPIO81, AF0, DRIVE_HIGH)
#define CAM_RESET_MAIN			MFP_CFG_LPM(GPIO82, AF0, DRIVE_HIGH)

#define GPIO83_FREE			MFP_CFG_X(GPIO83, AF0, DS02X, PULL_LOW)

#define CAMERA_ON			MFP_CFG_LPM(GPIO84, AF0, DRIVE_HIGH)
#define WLAN_BT_RESET                   MFP_CFG_LPM(GPIO85, AF0, DRIVE_LOW)
#define WLAN_BT_RESET_LPM_ON		MFP_CFG_LPM(GPIO85, AF0, DRIVE_HIGH)
#define WLAN_DAT3			MFP_CFG_X(GPIO86, AF0, DS02X, DRIVE_LOW)
#define WLAN_DAT3_LPM_ON		MFP_CFG_X(GPIO86, AF1, DS02X, PULL_LOW)
#define WLAN_DAT2			MFP_CFG_X(GPIO87, AF0, DS02X, DRIVE_LOW)
#define WLAN_DAT2_LPM_ON		MFP_CFG_X(GPIO87, AF1, DS02X, PULL_LOW)
#define WLAN_DAT1			MFP_CFG_X(GPIO88, AF0, DS02X, DRIVE_LOW)
#define WLAN_DAT1_LPM_ON		MFP_CFG_X(GPIO88, AF1, DS02X, PULL_LOW)
#define WLAN_DAT0			MFP_CFG_X(GPIO89, AF0, DS02X, DRIVE_LOW)
#define WLAN_DAT0_LPM_ON		MFP_CFG_X(GPIO89, AF1, DS02X, PULL_LOW)
#define WLAN_CMD			MFP_CFG_X(GPIO90, AF0, DS02X, DRIVE_LOW)
#define WLAN_CMD_LPM_ON			MFP_CFG_X(GPIO90, AF1, DS02X, PULL_LOW)
#define WLAN_CLK			MFP_CFG_X(GPIO91, AF0, DS02X, DRIVE_LOW)
#define WLAN_CLK_LPM_ON			MFP_CFG_X(GPIO91, AF1, DS02X, DRIVE_LOW)
#define GPIO92_FREE			MFP_CFG_X(GPIO92, AF0, DS01X, PULL_LOW_SEL)
#define GPIO93_FREE			MFP_CFG_X(GPIO93, AF0, DS01X, PULL_LOW_SEL)
#define SD_LDO_CE			MFP_CFG_X(GPIO94, AF0, DS01X, DRIVE_LOW)
#define SD_LDO_CE_ON			MFP_CFG_X(GPIO94, AF0, DS01X, DRIVE_HIGH)
#define FLASH_EN			MFP_CFG_X(GPIO95, AF0, DS02X, DRIVE_LOW)
#define HP_AMP_SD			MFP_CFG_X(GPIO96, AF0, DS03X, DRIVE_LOW)
#define TP_LDO_EN			MFP_CFG_X(GPIO97, AF0, DS01X, DRIVE_LOW)
#define I2C_SCL				MFP_CFG_X(GPIO98, AF2, DS03X, FLOAT)
#define I2C_SDA				MFP_CFG_X(GPIO99, AF2, DS03X, FLOAT)

#define OLED_D18				MFP_CFG_X(GPIO100, AF5, DS03X, DRIVE_LOW)
#define OLED_D19				MFP_CFG_X(GPIO101, AF5, DS03X, DRIVE_LOW)
#define OLED_D20				MFP_CFG_X(GPIO102, AF5, DS03X, DRIVE_LOW)
#define OLED_D21				MFP_CFG_X(GPIO103, AF5, DS03X, DRIVE_LOW)
#define OLED_D22				MFP_CFG_X(GPIO104, AF5, DS03X, DRIVE_LOW)
#define OLED_D23				MFP_CFG_X(GPIO105, AF5, DS03X, DRIVE_LOW)
#define GPS_ON				MFP_CFG_X(GPIO106, AF0, DS03X, DRIVE_LOW)
#define WLAN_PD_PW886			MFP_CFG_LPM(GPIO107, AF0, DRIVE_LOW)
#define WLAN_PD_PW886_LPM_ON		MFP_CFG_LPM(GPIO107, AF0, DRIVE_HIGH)
#define WLAN_WAKEUP_TAVOR		MFP_CFG_LPM(GPIO108, AF0, DRIVE_LOW)
#define WLAN_WAKEUP_TAVOR_LPM_ON	MFP_CFG_LPM(GPIO108, AF0, PULL_HIGH)
#define BT_WAKEUP_TAVOR			MFP_CFG_LPM(GPIO109, AF0, DRIVE_LOW)
#define BT_WAKEUP_TAVOR_LPM_ON		MFP_CFG_LPM(GPIO109, AF0, PULL_HIGH)
#define TAVOR_WAKEUP_WLAN		MFP_CFG_LPM(GPIO110, AF0, DRIVE_LOW)
#define TAVOR_WAKEUP_WLAN_LPM_ON	MFP_CFG_LPM(GPIO110, AF0, DRIVE_HIGH)
#define CAM_MCLK			MFP_CFG_LPM(GPIO111, AF2, PULL_LOW)

#define BENZINA2_ETH_PHYS	0x14000000

#define PMIC_INT_PIN		83		/* PMIC_INT to GPIO83 */


struct platform_mmc_slot {
	int gpio_cd;
	int gpio_wp;
};

extern struct platform_mmc_slot benzina2_mmc_slot[];
void benzina2_stereo_amp_en(int value);
void benzina2_ext_mono_amp_en(int value);

#endif /* __ASM_ARCH_BENZINA2_H */
