#ifndef __ASM_ARCH_BIGBROTHER_H
#define __ASM_ARCH_BIGBROTHER_H

#include <mach/mfp.h>

#define GPIO41_LCD_DD16             MFP_CFG(GPIO41, AF3)
#define GPIO42_LCD_DD17             MFP_CFG(GPIO42, AF3)
#define GPIO45_LCD_RESET            MFP_CFG(GPIO45, AF0)

#define GPS_LDO_EN		MFP_CFG_LPM(GPIO96, AF0, DRIVE_HIGH)
#define GPS_RESET		MFP_CFG_LPM(GPIO100, AF0, DRIVE_HIGH)
#define GPS_ON 			MFP_CFG_LPM(GPIO101, AF0, DRIVE_LOW)
#define GPS_RX 			MFP_CFG_LPM(GPIO102, AF1, FLOAT)
#define GPS_TX 			MFP_CFG_LPM(GPIO103, AF1, DRIVE_HIGH)

#define BIGBROTHER_ETH_PHYS	0x14000000

#define ULPI_RESET_PIN		53		/* DF_ADDR0 to GPIO53 */
#define PMIC_INT_PIN		83		/* PMIC_INT to GPIO83 */

/*
 * QCI HI & LO sensor enable
 */
#define QCI_HI_PWDN_PIN_BIGBROTHER         mfp_to_gpio(MFP_PIN_GPIO63)
#define QCI_LO_PWDN_PIN_BIGBROTHER         mfp_to_gpio(MFP_PIN_GPIO64)

struct platform_mmc_slot_bigbrother {
	int gpio_cd;
	int gpio_wp;
};

extern struct platform_mmc_slot_bigbrother bigbrother_mmc_slot[];
void bigbrother_stereo_amp_en(int value);
void bigbrother_ext_mono_amp_en(int value);

#endif /* __ASM_ARCH_BIGBROTHER_H */
