#ifndef __ASM_ARCH_CAMERA_H__
#define __ASM_ARCH_CAMERA_H__
#include <linux/i2c.h>
#define CCIC_0 0    // for 2 camera interface
#define CCIC_1 1
#define CCIC_NUM 2

#define SENSOR_LOW  0
#define SENSOR_HIGH 1
#define SENSOR_CLOSE  0
#define SENSOR_OPEN 1

struct cam_platform_data {
	unsigned int vsync_gpio;
	int (*init)(void);
	void (*deinit)(void);
	void (*suspend)(void);
	void (*resume)(void);
	void (*sync_to_gpio)(void);
	void (*sync_from_gpio)(void);
	int (*power_set)(int);
};

struct sensor_platform_data {
	int id;
	int (*power_on)(int);
	int (*power_off)(int);
	int (*power_set)(int res, int flag);
	int (*voltage_on)(int);		/* power voltage on */
	int (*voltage_off)(int);	/* power voltage off */
	int (*reset)(int);		/* reset chip */
	int (*flash_ctrl)(int);		/* flash control */
	int (*standby)(int);		/* enter standby */
	int (*wakeup)(int);		/* wakeup */
};

extern int ccic_sensor_attach(struct i2c_client *client);

#endif

