/*
 *     compass_sensor.h- ST MEMS motion sensor
 *
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; version 2 of the License.
 */
#ifndef __COMPASS_H__
#define __COMPASS_H__

#include <linux/device.h>
/*ADD COMPASS MACRO HERE*/
#define COMPASS_MAX_INTERVAL 2000
#define COMPASS_MIN_INTERVAL 200
#define MG_PER_SAMPLE			18
#define SWITCH_ON			1
#define SWITCH_OFF			0
#define COMPASS_DEBUG_FLOOD		1985
#define COMPASS_STATUS	0xc0
#define COMPASS_TEMP 	0xc1
#define COMPASS_X 	0xc2
#define COMPASS_Y 	0xc3
#define COMPASS_Z 	0xc4
#define COMPASS_MODE 	0xe0
#define SENSOR_MEASURE 0x00

struct compass_platform_data {
	int	(*init_irq)(void);
	int	(*ack_irq)(void);
	unsigned int	power_pin;
	unsigned int 	reset_pin;
};

#if 0 
typedef struct {
	atomic_t g_rdy;
	struct list_head  list;
}compass_status_t;

typedef struct {
	char 					*name;
	struct i2c_client			 *compass_client;
	compass_status_t  			 *status_p;
	struct sensors_dev 			*device;
	struct i2c_driver			*driver;
	atomic_t   				rf_count;
	struct  list_head  			open_list;
	wait_queue_head_t			compass_wait;
	struct work_struct			compass_work;
	unsigned int				switch_on;
	struct semaphore			mutex;
	spinlock_t				list_lock;
	
	struct timer_list			timer;
	void 					*private;
}compass_device_t;
#endif
#endif
