#ifndef __ASM_ARCH_INNODEV_H__
#define __ASM_ARCH_INNODEV_H__

struct innodev_platform_data {
	int (*voltage_on)(void);	/* power voltage on */
	int (*voltage_off)(void);	/* power voltage off */
	int (*reset)(void);		/* reset chip */
	int fw_spi_download;		/* =1, need download firmware by SPI */
	int irq;			/* interrupt */
	char *fw_name;			/* firmware file name */
};

struct innodev_platform_spi {
	int ssp_port;			/* PXA SSP port for SPI interface */
	unsigned int spi_cs_gpio;	/* SPI CS GPIO pin */
	int (*spi_cs_to_gpio)(void);	/* config SPI CS to GPIO function */
	int (*spi_cs_to_ssp)(void);	/* config SPI CS to SSP function */
};

#endif
