#ifndef _LEVANTE_HW_H_
#define _LEVANTE_HW_H_

	/*----------------------------------------------------
					SANREMO
	* --------------------------------------------------*/
	/****** In LEVANTE == total votage is 1.80 volt and 12 bits
	===>> so basically************/
	/******               each bit in the  register
	represent a 0.000439 volt    ************/
	/*(1.8 / 2^12) * 10^6 (each bit in the  register
	represent 439 microvolt)*/
#define LEVANTE_COEFFICIENT		439

	/*----------------------------------------------------
		SANREMO REGISTERS
	*--------------------------------------------------*/
#define LEVATNE_A0_ID  	0x40
#define LEVATNE_A1_ID  	0x41
#define LEVATNE_B0_ID  	0x48
#define LEVATNE_END_ID 	LEVATNE_B0_ID

#define PORTOFINO_A0_ID 	0x60
#define PORTOFINO_A1_ID 	0x48
#define PORTOFINO_A2_ID 	0x41
#define PORTOFINO_END_ID 	PORTOFINO_A2_ID

#define SANREMO_CHIP_ID             0x00
#define SANREMO_STS_PWDOWN_STATUS_A0   0x01
#define SANREMO_STS_OVER_TEMP           (1 << 0)
#define SANREMO_STS_PWDOWN              (1 << 3)
#define SANREMO_STS_SYSEN               (1 << 4)
#define SANREMO_STS_WD                  (1 << 5)
#define SANREMO_STS_LONG_ONKEY          (1 << 6)
#define SANREMO_STS_PWR_HOLD            (1 << 7)
#define SANREMO_STS_RESET               (1 << 8)

#define SANREMO_STATUS_B0           0x01
#define SANREMO_STS_CC                	(1 << 3)
/* all other bits are same as SANREMO_STATUS bellow*/

#define SANREMO_STATUS              0x02
#define SANREMO_STS_ONKEY               (1 << 0)
#define SANREMO_STS_EXTON               (1 << 1)
#define SANREMO_STS_CHG                 (1 << 2)
#define SANREMO_STS_BAT                 (1 << 3)
 /* 1 - pen down , 0 - pen up*/
#define SANREMO_STS_PEN_DOWN            (1 << 4)
#define SANREMO_STS_HEADSET             (1 << 5)
#define SANREMO_STS_HOOK                (1 << 6)
#define SANREMO_STS_MICIN               (1 << 7)

#define SANREMO_INT_STATUS_1        0x03
#define SANREMO_INT_STS1_ONKEY          (1 << 0)
#define SANREMO_INT_STS1_EXTON          (1 << 1)
#define SANREMO_INT_STS1_CHG            (1 << 2)
#define SANREMO_INT_STS1_BAT            (1 << 3)
#define SANREMO_INT_STS1_RTC            (1 << 4)

#define SANREMO_INT_STATUS_2        0x04
#define SANREMO_INT_STS2_VBAT            (1 << 0)
#define SANREMO_INT_STS2_VCHG            (1 << 1)
#define SANREMO_INT_STS2_VSYS            (1 << 2)
#define SANREMO_INT_STS2_TINT            (1 << 3)
#define SANREMO_INT_STS2_GPADC0          (1 << 4)
#define SANREMO_INT_STS2_GPADC1          (1 << 5)
#define SANREMO_INT_STS2_GPADC2          (1 << 6)
#define SANREMO_INT_STS2_GPADC3          (1 << 7)

#define SANREMO_INT_STATUS_3        0x05
/*#define SANREMO_INT_AUDIO_SHORT            (1 << 0)*/
#define SANREMO_INT_STS3_PEN             (1 << 1)
#define SANREMO_INT_STS3_HEADSET         (1 << 2)
#define SANREMO_INT_STS3_HOOK            (1 << 3)
#define SANREMO_INT_STS3_MICIN           (1 << 4)
#define SANREMO_INT_STS3_CHG_FAIL        (1 << 5)
#define SANREMO_INT_STS3_CHG_DONE        (1 << 6)
#define SANREMO_INT_STS3_CHG_IOVER       (1 << 7)

#define SANREMO_EVENT_CHARGER            0xFFFFFFFF

#define SANREMO_INT_EN_1            0x06
#define SANREMO_INT_EN_ONKEY            (1 << 0)
#define SANREMO_INT_EN_EXTON            (1 << 1)
#define SANREMO_INT_EN_CHG              (1 << 2)
#define SANREMO_INT_EN_BAT              (1 << 3)
#define SANREMO_INT_EN_RTC              (1 << 4)

#define SANREMO_INT_EN_2            0x07
#define SANREMO_INT_EN_VBAT             (1 << 0)
#define SANREMO_INT_EN_VCHG             (1 << 1)
#define SANREMO_INT_EN_VSYS             (1 << 2)
#define SANREMO_INT_EN_TINT             (1 << 3)
#define SANREMO_INT_EN_GPADC0           (1 << 4)
#define SANREMO_INT_EN_TBAT             (1 << 5)
#define SANREMO_INT_EN_GPADC2           (1 << 6)
#define SANREMO_INT_EN_GPADC3           (1 << 7)

#define SANREMO_INT_EN_3            0x08
/*#define SANREMO_INT_EN_AUDIO_SHORT        (1 << 0)*/
#define SANREMO_INT_EN_PEN              (1 << 1)
#define SANREMO_INT_EN_HEADSET          (1 << 2)
#define SANREMO_INT_EN_HOOK             (1 << 3)
#define SANREMO_INT_EN_MICIN            (1 << 4)
#define SANREMO_INT_EN_CHG_FAIL         (1 << 5)
#define SANREMO_INT_EN_CHG_DONE         (1 << 6)
#define SANREMO_INT_EN_CHG_IOVER        (1 << 7)

#define SANREMO_DEBOUNCE_REG		0x0A
#define SANREMO_DEBOUNCE_PEN_DET(x) (x << 0)
#define SANREMO_DEBOUNCE_CHG(x)     (x << 2)
#define SANREMO_DEBOUNCE_EXTON(x)   (x << 4)
#define SANREMO_DEBOUNCE_ONKEY(x)   (x << 6)

#define SANREMO_WAKEUP_REG				0x0B
#define SANREMO_WAKEUP_PRESS_TIME       (1 << 0)
#define SANREMO_WAKEUP_LONG_ONKEY_EN    (1 << 1)
#define SANREMO_WAKEUP_WD_TIMER_COUNT   (0xF << 2)
#define SANREMO_WAKEUP_WD_EN            (1 << 6)
#define SANREMO_WAKEUP_PWR_HOLD         (1 << 7)
#define SANREMO_POWERHOLD_WD_EN_MASK    0xE7

/* Levante B0 */
#define SANREMO_MIS1_REG				0x0C
#define SANREMO_MIS1_PWR_HOLD			(1 << 7)
#define SANREMO_LDO3					0x12
#define SANREMO_LDO4					0x13
#define SANREMO_LDO4_VLDO4_SET			(1 << 0)
#define SANREMO_LDO4_VLDO4_SET_SLP		(1 << 3)
#define SANREMO_LDO12					0x1A

#define SANREMO_SLEEP_MODE1_REG    0x1C
#define SANREMO_SLEEP_MODE2_REG    0x1D
#define SANREMO_SLEEP_MODE3_REG    0x1E
#define SANREMO_SLEEP_MODE4_REG    0x1F

#define SANREMO_VBUCK_SET_SLEEP1   0x21
#define SANREMO_VBUCK_SET_SLEEP2   0x22
#define SANREMO_VBUCK_SET_SLEEP3   0x23

#define SANREMO_VBUCK1_SET			0x24
#define SANREMO_VBUCK2_SET			0x25

#define SANREMO_BUCK_CONTROLS     	0x27

#define SANREMO_VIBRA_SET     		0x28
#define SANREMO_VIBRA_SET_LDO13_EN		(1 << 0)
#define SANREMO_VIBRA_SET_LDO13_SET		(0x7 << 2)
#define SANREMO_VIBRA_SET_PWM_ON		(1 << 4)
#define SANREMO_VIBRA_SET_PWM_FREQ 		(7 << 5)

#define SANREMO_VIBRA_PWM     		0x29

#define SANREMO_LP_CONFIG1         0x35
#define SANREMO_LP_CONFIG2         0x36

#define SANREMO_HEADSET_DETECTION_B0    0x38
#define SANREMO_HEADSET_MIC_DET_RES_B0  (1 << 7)


#define SANREMO_LP_CONFIG3			0x39

#define SANREMO_GENERAL_USE			0x3E

#define SANREMO_MISC1				0x40
#define SANREMO_MCLK				0x41
#define SANREMO_MIS_REG2			0x42
#define SANREMO_MIS_REG2_AUDIO_PU		(1 << 3)
#define SANREMO_MIS_REG2_AUDIO_RSTB		(1 << 4)
#define SANREMO_MIS_REG2_PLL_PU			(1 << 5)

#define	SANREMO_AUDIO_REG_BASE1		SANREMO_MISC1
#define	SANREMO_AUDIO_REG_END1		0x46
#define SANREMO_CC_READ			0x47
/*Charger*/
#define SANREMO_CHG_CTRL1			0x48
#define SANREMO_CHG_CTRL2			0x49
#define SANREMO_CHG_CTRL3			0x4A
#define SANREMO_CHG_CTRL4			0x4B
#define SANREMO_CHG_CTRL5           0x4C
#define SANREMO_BB_CHG_TO_BAT   	(1 << 2)

#define SANREMO_CHG_CTRL6           0x4D
#define SANREMO_CHG_CTRL7         	0x4E

#define SANREMO_GP_BIAS_1           0x4F
#define SANREMO_GP_BIAS_1_GP2(x)    (x & 0x0F)
#define SANREMO_GP_BIAS_1_GP3(x)    (x << 4)



#define SANREMO_MEAS_ENABLE1        0x50
#define SANREMO_MEAS_EN1_VBAT           (1 << 0)
#define SANREMO_MEAS_EN1_VCHG           (1 << 1)
#define SANREMO_MEAS_EN1_VSYS           (1 << 2)
#define SANREMO_MEAS_EN1_TINT           (1 << 3)
#define SANREMO_MEAS_EN1_RFTMP          (1 << 4)
#define SANREMO_MEAS_EN1_TBAT           (1 << 5)
#define SANREMO_MEAS_EN1_GPADC2        	(1 << 6)
#define SANREMO_MEAS_EN1_GPADC3         (1 << 7)

#define SANREMO_MEAS_ENABLE2        0x51
#define SANREMO_MEAS_ENABLE3        0x52
#define SANREMO_MEAS_EN3_IBAT           (1 << 0)
#define SANREMO_MEAS_EN3_IBAT_COMP      (1 << 1)
#define SANREMO_MEAS_EN3_BAT_DET_EN	    (1 << 1)
#define SANREMO_MEAS_EN3_COULOMB_COUNTER (1 << 2)
#define SANREMO_MEAS_EN3_PENDET         (1 << 3)
#define SANREMO_MEAS_EN3_TSIX			(1 << 4)
#define SANREMO_MEAS_EN3_TSIY           (1 << 5)
#define SANREMO_MEAS_EN3_TSIZ1        	(1 << 6)
#define SANREMO_MEAS_EN3_TSIZ2         	(1 << 7)

#define SANREMO_MEAS_OFF_TIME1		0x53
#define SANREMO_MEASOFFTIME1_BAT_DET_EN_A1 		(1 << 0)
#define SANREMO_MEASOFFTIME1MEAS_OFFTIME1_A1(x) (x << 1)
#define SANREMO_MEASOFFTIME1MEAS_DOUBLE_TSI_B   (1 << 0)
#define SANREMO_MEASOFFTIME1MEAS_EN_SLP_B    	(1 << 1)
#define SANREMO_MEASOFFTIME1MEAS_OFFTIME1_B(x)  (x << 2)


#define SANREMO_MEAS_OFF_TIME2         	0x54
#define SANREMO_MEASOFFTIME1_CHECK_DIS	(1 << 0)

#define SANREMO_TSI_PREBIAS_TIME	0x55
#define SANREMO_PD_PREBIAS_TIME		0x56
#define SANREMO_PD_PREBIAS_TIME_MASK				(0xFF << 0)

#define SANREMO_GPADC_MISC1         0x57
#define SANREMO_GPADC_MISC1_GPFSM_EN 		  (1 << 0)
#define SANREMO_GPPADC_GP_PREBIAS_TIME_A1(x)  (x << 1)
#define SANREMO_GPPADC_GP_PREBIAS_TIME_B0(x)  (x << 1)
#define SANREMO_GPPADC_SLOW_MODE(x)		  	  (x << 3)
#define SANREMO_GPADC_MISC1_MASK  \
	(SANREMO_GPADC_MISC1_GPFSM_EN | SANREMO_GPPADC_GP_PREBIAS_TIME)

#define SANREMO_GPADC_MISC2         0x59
#define SANREMO_GPADC0_GP_BIAS_A0	(1 << 0)
#define SANREMO_GPADC1_GP_BIAS_A1	(1 << 1)
#define SANREMO_GPADC2_GP_BIAS_A2	(1 << 2)
#define SANREMO_GPADC3_GP_BIAS_A3	(1 << 3)

#define SANREMO_GP_BAIS_REG2		0x5A
#define SANREMO_VBAT_LOW_TH 		0x5B
#define SANREMO_VCHG_LOW_TH 		0x5C
#define SANREMO_VSYS_LOW_TH 		0x5D
#define SANREMO_TINT_LOW_TH  		0x5E
#define SANREMO_GPADC1_LOW_TH  		0x60

#define SANREMO_VBAT_UPP_TH			0x63
#define SANREMO_VCHG_UPP_TH 	  	0x64
#define SANREMO_TINT_UPP_TH  	  	0x66
#define SANREMO_GPADC1_UPP_TH      	0x68


#define SANREMO_IBAT_MEAS1			0x6B
#define SANREMO_IBAT_MEAS2			0x6C
#define SANREMO_VBAT_MEAS1          0x6D
#define SANREMO_VBAT_MEAS2          0x6E
#define SANREMO_VCHG_MEAS1          0x6F
#define SANREMO_VCHG_MEAS2          0x70
#define SANREMO_VSYS_MEAS1          0x71
#define SANREMO_VSYS_MEAS2          0x72
#define SANREMO_TINT_MEAS1			0x73
#define SANREMO_TINT_MEAS2			0x74
#define SANREMO_GPADC0_MEAS1        0x75
#define SANREMO_GPADC0_MEAS2        0x76
#define SANREMO_GPADC1_MEAS1        0x77
#define SANREMO_GPADC1_MEAS2        0x78
#define SANREMO_GPADC2_MEAS1        0x79
#define SANREMO_GPADC2_MEAS2        0x7A
#define SANREMO_GPADC3_MEAS1        0x7B
#define SANREMO_GPADC3_MEAS2        0x7C
#define SANREMO_TSIX_MEAS1 			0x8D
#define SANREMO_TSIX_MEAS2 			0x8E
#define SANREMO_TSIY_MEAS1 			0x8F
#define SANREMO_TSIY_MEAS2 			0x90
#define SANREMO_TSIZ1_MEAS1 	  	0x91
#define SANREMO_TSIZ1_MEAS2 	  	0x92
#define SANREMO_TSIZ2_MEAS1 	  	0x93
#define SANREMO_TSIZ2_MEAS2 	  	0x94

#define SANREMO_SUPPLIES_EN11       0x2B
#define SANREMO_SUPPEN11_LDO5_EN1       (1 << 7)
#define SANREMO_SUPPEN11_LDO4_EN1       (1 << 6)

#define SANREMO_SUPPLIES_EN12       0x2C
#define	SANREMO_AUDIO_REG_BASE2		0xB0

/*Test registers for FSM debug, Address 0xC8 to 0xCF Page 1*/
#define        SANREMO_TEST_PAGE1_C8           0xC8
#define        SANREMO_TEST_PAGE1_C9           0xC9
#define        SANREMO_TEST_PAGE1_CA           0xCA
#define        SANREMO_TEST_PAGE1_CB           0xCB
#define        SANREMO_TEST_PAGE1_CC           0xCC
#define        SANREMO_TEST_PAGE1_CD           0xCD
#define        SANREMO_TEST_PAGE1_CE           0xCE
#define        SANREMO_TEST_PAGE1_CF           0xCF
#define        SANREMO_TEST_PAGE1_D6           0xD6
#define        SANREMO_TEST_PAGE1_D7           0xD7


#define SANREMO_ADC_ANALOG_PROGRAM1 0xD0
#define SANREMO_ADC_ANA_PRO1_EN_MICBIAS_1_2_BIT        (1 << 2)
#define SANREMO_ADC_ANA_PRO1_EN_MICBIAS_1_PAD_BITS     ((1 << 4) | (1 << 3))
#define SANREMO_ADC_ANA_PRO1_EN_MICBIAS_2_PAD_BITS     ((0 << 6) | (1 << 5))



#define SANREMO_MIC_BUTTON_DETECTION 0xE9
#define SANREMO_EN_MIC_DET           (1 << 0)
#define SANREMO_BTN_DEBOUNCE         (1 << 5)


#define        SANREMO_SHORT_REG                       0xEB
#define SANREMO_SHORT_REG_HS1_SHORT_P_BIT (1 << 1)
#define SANREMO_SHORT_REG_HS2_SHORT_P_BIT (1 << 3)
#define SANREMO_SHORT_LO1_SHORT_P_BIT (1 << 5)
#define SANREMO_SHORT_LO2_SHORT_P_BIT (1 << 7)


#define        SANREMO_HEADSET_DETECTION    0xEA
#define SANREMO_HEADSET_DET_ENA                (1 << 0)
#define SANREMO_HEADSET_PERIOD1000MS	(~((1 << 2) | (1 << 1)))
#define SANREMO_HEADSET_PERIOD250MS		((1 << 2) | (0 << 1))
#define SANREMO_HEADSET_PERIODCONT		((1 << 2) | (1 << 1))

#define SANREMO_AUDIO_SUPPLIES2     0xDC
#define SANREMO_REG27_MPU           (1 << 3)

#define SANREMO_AUDIO_REG_END2      0xEB /* SANREMO_SHORT_REG */

#define SANREMO_CODEC_REG_BASE1     0x00
#define SANREMO_CODEC_REG_END1      \
	(SANREMO_AUDIO_REG_END1 - SANREMO_AUDIO_REG_BASE1)

#define SANREMO_CODEC_REG_BASE2     \
	(SANREMO_CODEC_REG_END1 + 1)
#define SANREMO_CODEC_REG_END2      \
	(SANREMO_AUDIO_REG_END2 - SANREMO_AUDIO_REG_BASE2 + \
	SANREMO_CODEC_REG_BASE2)

#define SANREMO_AUDIO_REGS_NUM     \
	(SANREMO_CODEC_REG_END2 + 1)

#define	LEVANTE_MISC1                0x0
#define	LEVANTE_MCLK                 0x1
#define	LEVANTE_MISC2                0x2
#define	LEVANTE_PLL_CTRL1            0x3
#define	LEVANTE_PLL_FRAC1            0x4
#define	LEVANTE_PLL_FRAC2            0x5
#define	LEVANTE_PLL_FRAC3            0x6
#define	LEVANTE_PCM_INTERFACE1       0x7
#define	LEVANTE_PCM_INTERFACE2       0x8
#define	LEVANTE_PCM_INTERFACE3       0x9
#define	LEVANTE_PCM_RATE             0xA
#define	LEVANTE_ECHO_CANCEL_PATH     0xB
#define	LEVANTE_SIDETONE_GAIN1       0xC
#define	LEVANTE_SIDETONE_GAIN2       0xD
#define	LEVANTE_SIDETONE_GAIN3       0xE
#define	LEVANTE_ADC_OFFSET1          0xF
#define	LEVANTE_ADC_OFFSET2          0x10
#define	LEVANTE_DMIC_DELAY           0x11
#define	LEVANTE_I2S_INTERFACE1       0x12
#define	LEVANTE_I2S_INTERFACE2       0x13
#define	LEVANTE_I2S_INTERFACE3       0x14
#define	LEVANTE_I2S_INTERFACE4       0x15
#define	LEVANTE_EQUALIZER_N0_1       0x16
#define	LEVANTE_EQUALIZER_N0_2       0x17
#define	LEVANTE_EQUALIZER_N1_1       0x18
#define	LEVANTE_EQUALIZER_N1_2       0x19
#define        LEVANTE_EQUALIZER_D1_1       0x1A
#define        LEVANTE_EQUALIZER_D1_2       0x1B
#define	LEVANTE_SIDE_TONE1           0x1C
#define	LEVANTE_SIDE_TONE2           0x1D
#define	LEVANTE_LEFT_GAIN1           0x1E
#define	LEVANTE_LEFT_GAIN2           0x1F
#define	LEVANTE_RIGHT_GAIN1          0x20
#define	LEVANTE_RIGHT_GAIN2          0x21
#define	LEVANTE_DAC_OFFSET           0x22
#define	LEVANTE_OFFSET_LEFT1         0x23
#define	LEVANTE_OFFSET_LEFT2         0x24
#define	LEVANTE_OFFSET_RIGHT1        0x25
#define	LEVANTE_OFFSET_RIGHT2        0x26
#define	LEVANTE_ADC_ANALOG_PROGRAM1  0x27
#define	LEVANTE_ADC_ANALOG_PROGRAM2  0x28
#define	LEVANTE_ADC_ANALOG_PROGRAM3  0x29
#define	LEVANTE_ADC_ANALOG_PROGRAM4  0x2A
#define	LEVANTE_ANALOG_TO_ANALOG     0x2B
#define	LEVANTE_HS1_CTRL             0x2C
#define	LEVANTE_HS2_CTRL             0x2D
#define	LEVANTE_LO1_CTRL             0x2E
#define	LEVANTE_LO2_CTRL             0x2F
#define	LEVANTE_EAR_SPKR_CTRL1       0x30
#define	LEVANTE_EAR_SPKR_CTRL2       0x31
#define	LEVANTE_AUDIO_SUPPLIES1      0x32
#define	LEVANTE_AUDIO_SUPPLIES2      0x33
#define	LEVANTE_ADC_ENABLES1         0x34
#define	LEVANTE_ADC_ENABLES2         0x35
#define	LEVANTE_DAC_ENABLES1         0x36
#define	LEVANTE_DUMMY                0x37
#define	LEVANTE_DAC_ENABLES2         0x38
#define	LEVANTE_AUDIO_CAL1           0x39
#define	LEVANTE_AUDIO_CAL2           0x3A
#define	LEVANTE_AUDIO_CAL3           0x3B
#define	LEVANTE_AUDIO_CAL4           0x3C
#define	LEVANTE_AUDIO_CAL5           0x3D
#define	LEVANTE_ANALOG_INPUT_SEL1    0x3E
#define	LEVANTE_ANALOG_INPUT_SEL2    0x3F
#define	LEVANTE_MIC_BUTTON_DETECTION 0x40
#define	LEVANTE_HEADSET_DETECTION    0x41
#define	LEVANTE_SHORTS               0x42


	/*----------------------------------------------------
			PORTOFINO REGISTERS
	*--------------------------------------------------*/
#define PORTOFINO_PREREG_REG1       0x10
#define PORTOFINO_PREREG_CURLIM         (1 << 0)
#define PORTOFINO_PREREG_VSYS           (1 << 4)
#define PORTOFINO_PREREG_CURLIM_BIT     (0)
#define PORTOFINO_PREREG_VSYS_BIT       (4)

#define PORTOFINO_WLED1A       0x02
#define PORTOFINO_WLED1B       0x03
#define PORTOFINO_WLED2A       0x04
#define PORTOFINO_WLED2B       0x05
#define PORTOFINO_WLED3A       0x06
#define PORTOFINO_WLED3B       0x07
#define PORTOFINO_WLED_100DUTY	(1 << 0)
#define PORTOFINO_PF_VIBRATOR1	0x12
#define PORTOFINO_PF_VIBRATOR2	0x13
#define PORTOFINO_VSYS		0x15
#define PORTOFINO_VSYS_VBUS_OVP                (1 << 0)
#define PORTOFINO_VSYS_ENABLE                  (1 << 1)
#define PORTOFINO_VSYS_BYPASS_OVTEMP   (1 << 2)
#define PORTOFINO_VSYS_AUTORECOVER             (1 << 3)
#define PORTOFINO_VSYS_FORCERECOVER            (1 << 4)

#define PORTOFINO_USB_MISC          0x16
#define PORTOFINO_USB_MISC_SW_OFF      (1 << 0)
#define PRTOFINIO_USB_MISC_OSC_EN_BIT   (1 << 4)

#define PORTOFINO_DIE_REVISION_ID  	0x17

#endif  /* _LEVANTE_HW_H_ */

