#ifndef	__ASMARM_ARCH_PART_TABLE_H__
#define	__ASMARM_ARCH_PART_TABLE_H__

/* We predefine sample partition tables here. Platform just pick one. */
static struct mtd_partition __attribute__((unused))
	pxa320_128m_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x040000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x040000,
		.size        = 0x200000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[2] = {
		.name        = "Filesystem",
		.offset      = 0x0240000,
		.size        = 0x3000000,     /* only mount 48M fs */
	},
	[3] = {
		.name        = "MassStorage",
		.offset      = 0x3240000, 
		.size        = 0x3d60000,
	},
	[4] = {
		.name        = "BBT",
		.offset      = 0x6FA0000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},

	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	pxa300_128m_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x060000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x060000,
		.size        = 0x200000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[2] = {
		.name        = "Filesystem",
		.offset      = 0x0260000,
		.size        = 0x3000000,     /* only mount 48M fs */
	},
	[3] = {
		.name        = "MassStorage",
		.offset      = 0x3260000,
		.size        = 0x3d40000,		/* 61.25M */
	},
	[4] = {
		.name        = "BBT",
		.offset      = 0x6FA0000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	pxa930_128m_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x00100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x00100000,
		.size        = 0x00200000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[2] = {
		.name        = "Filesystem",
		.offset      = 0x00300000,
		.size        = 0x03000000,     /* only mount 48M fs */
	},
	[3] = {
		.name        = "MassStorage",
		.offset      = 0x03300000,
		.size        = 0x03E60000,		/*  62.375M */
	},
	[4] = {
		.name        = "NVM",
		.offset      = 0x07160000,
		.size        = 0x00020000,		/* 128K */
	},
	[5] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x7180000, 
		.size        = 0x0800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[6] = {
		.name        = "MassStorage2",
		.offset      = 0x7980000, 
		.size        = 0x0380000,	/* 3.5M */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0x7d00000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	pxa930_256m_partitions[] = {
	[0] = {
#ifdef CONFIG_BLK_DEV_INITRD
		.name        = "init",
		.offset      = 0xc0000,
		.size        = 0x40000,
#else
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
#endif
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x0100000,
		.size        = 0x0200000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[2] = {
		.name        = "Filesystem",
		.offset      = 0x0300000,
		.size        = 0x3000000,     /* only mount 48M fs */
	},
	[3] = {
		.name        = "MassStorage",
		.offset      = 0x3300000,
		.size        = 0xBE60000,		/*  190.375M */
	},
	[4] = {
		.name        = "NVM",
		.offset      = 0xF160000,
		.size        = 0x0020000,     /* 128K */
	},
	[5] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0xF180000,
		.size        = 0x0800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[6] = {
		.name        = "MassStorage2",
		.offset      = 0xF980000,
		.size        = 0x0100000,	/* 1M */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0xfa80000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	pxa930_128m_v75_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "NVM",
		.offset      = 0x100000,
		.size        = 0x020000,
	},
	[2] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x120000, 
		.size        = 0x800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},	
	[3] = {
		.name        = "Kernel",
		.offset      = 0x920000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[4] = {
		.name        = "Filesystem",
		.offset      = 0x0c20000,
		.size        = 0x4000000,     /* only mount 64M fs */
	},
	[5] = {
		.name        = "MassStorage",
		.offset      = 0x4c20000,
		.size        = 0x30e0000,		/* 48.875M */
	},
	[6] = {
		.name        = "BBT",
		.offset      = 0x7d00000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	pxa930_256m_v75_partitions[] = {
	[0] = {
#ifdef CONFIG_BLK_DEV_INITRD
		.name        = "init",
		.offset      = 0xc0000,
		.size        = 0x40000,
#else
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
#endif
	},
	[1] = {
		.name        = "NVM",
		.offset      = 0x100000,
		.size        = 0x020000,
	},
	[2] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x120000, 
		.size        = 0x800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},	
	[3] = {
		.name        = "Kernel",
		.offset      = 0x920000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[4] = {
		.name        = "Filesystem",
		.offset      = 0x0c20000,
		.size        = 0x5000000,     /* only mount 80M fs */
	},
	[5] = {
		.name        = "MassStorage",
		.offset      = 0x5c20000,
		.size        = 0x9e60000,		/* 158.375M  */
	},
	[6] = {
		.name        = "BBT",
		.offset      = 0xfa80000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

/* This partition table is specific for Android project. Because Android
 * init will mount partition according to the partition name.
 */
static struct mtd_partition __attribute__((unused))
	android_128m_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x100000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[2] = {
		.name        = "system",
		.offset      = 0x0400000,
		.size        = 0x3000000,     /* mount 48M fs */
	},
	[3] = {
		.name        = "userdata",
		.offset      = 0x3400000,
		.size        = 0x3D60000,     /* mount 61.375M fs */
	},
	[4] = {
		.name        = "NVM",
		.offset      = 0x7160000,
		.size        = 0x0020000,     /* 128K */
	},
	[5] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x7180000,
		.size        = 0x0800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[6] = {
		.name        = "MassStorage",
		.offset      = 0x7980000,
		.size        = 0x0380000,	/* 3.5M */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0x7d00000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	android_256m_partitions[] = {
	[0] = {
#ifdef CONFIG_BLK_DEV_INITRD
		.name        = "init",
		.offset      = 0xc0000,
		.size        = 0x40000,
#else
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
#endif
	},
	[1] = {
		.name        = "Kernel",
		.offset      = 0x100000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[2] = {
		.name        = "system",
		.offset      = 0x0400000,
		.size        = 0x4000000,     /* mount 64M fs */
	},
	[3] = {
		.name        = "userdata",
		.offset      = 0x4400000,
		.size        = 0xAD60000,     /* mount 96M fs */
	},
	[4] = {
		.name        = "NVM",
		.offset      = 0xF160000,
		.size        = 0x0020000,     /* 128K */
	},
	[5] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0xF180000,
		.size        = 0x0800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[6] = {
		.name        = "MassStorage",
		.offset      = 0xF980000,
		.size        = 0x0100000,	/* 1M */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0xfa80000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	android_128m_v75_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "NVM",
		.offset      = 0x100000,
		.size        = 0x020000,
	},
	[2] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x120000, 
		.size        = 0x800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},	
	[3] = {
		.name        = "Kernel",
		.offset      = 0x920000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[4] = {
		.name        = "system",
		.offset      = 0x0c20000,
		.size        = 0x4000000,     /* mount 64M fs */
	},
	[5] = {
		.name        = "userdata",
		.offset      = 0x4c20000,
		.size        = 0x20E0000,     /* mount 32.875M */
	},
	[6] = {
		.name        = "filesystem",
		.offset      = 0x6d00000,
		.size        = 0x1000000,     /* mount 16M fs */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0x7d00000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	android_256m_v75_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "NVM",
		.offset      = 0x100000,
		.size        = 0x020000,
	},
	[2] = {
		.name        = "Arbel and Greyback Image",
		.offset      = 0x120000, 
		.size        = 0x800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},	
	[3] = {
		.name        = "Kernel",
		.offset      = 0x920000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[4] = {
		.name        = "system",
		.offset      = 0x0c20000,
		.size        = 0x4000000,     /* mount 64M fs */
	},
	[5] = {
		.name        = "userdata",
		.offset      = 0x4c20000,
		.size        = 0x9e60000,     /* mount 158.375M fs */
	},
	[6] = {
		.name        = "filesystem",
		.offset      = 0xea80000,
		.size        = 0x1000000,     /* mount 16M fs */
	},
	[7] = {
		.name        = "BBT",
		.offset      = 0xfa80000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

static struct mtd_partition __attribute__((unused))
	android_512m_v75_partitions[] = {
	[0] = {
		.name        = "Bootloader",
		.offset      = 0,
		.size        = 0x100000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[1] = {
		.name        = "security",
		.offset      = 0x100000,
		.size        = 0x040000,
		.mask_flags  = MTD_WRITEABLE, /* force read-only */
	},
	[2] = {
		.name        = "cpImage",
		.offset      = 0x140000, 
		.size        = 0x800000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},	
	[3] = {
		.name        = "NVM",
		.offset      = 0x940000,
		.size        = 0x0c0000,
	},
	[4] = {
		.name        = "logo",
		.offset      = 0xa00000, 
		.size        = 0x040000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},

	[5] = {
		.name        = "Kernel",
		.offset      = 0xA40000,
		.size        = 0x300000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	[6] = {
		.name        = "system",
		.offset      = 0x0d40000,
		.size        = 0x9800000,     /* mount 64M fs */
	},
	[7] = {
		.name        = "opl",
		.offset      = 0xa540000,     /* mount 32M fs */
		.size        = 0x3000000,
	},
	[8] = {
		.name        = "local",
		.offset      = 0xd540000,
		.size        = 0x1000000,     /* mount 16M fs */
	},
	[9] = {
		.name        = "fota",
		.offset      = 0xe540000,
		.size        = 0x0600000,     /* mount 10M fs */
	},
	[10] = {
		.name        = "cache",
		.offset      = 0xeb40000,
		.size        = 0x8c0000,     /* mount 16M fs */
	},
	[11] = {
		.name        = "ftm",       /* mount 8.725M fs */
		.offset      = 0xf400000,
		.size        = 0x0600000,
	},
	[12] = {
		.name        = "panic",       /* mount 8.725M fs */
		.offset      = 0xfa00000,
		.size        = 0x0080000,
	},
	[13] = {
		.name        = "userdata",
		.offset      = 0x10000000,
		.size        = 0xf580000,     /* mount 16M fs */
	},
	[14] = {
		.name        = "BBT",
		.offset      = 0x1f580000,
		.size        = 0x0080000,
		.mask_flags  = MTD_WRITEABLE,  /* force read-only */
	},
	/* NOTES: We reserve some blocks for PXA3xx BBM at the end of NAND.
	 * And the max relocation blocks is not same on different platform.
	 * Please take care it when define the partition table.
	 */
};

#endif

