/*
 * PXA3xx PM Check Definations 
 *
 * Copyright (C) 2008, Borqs Ltd. (emichael.li@borqs.com).
 * All Rights Reserved
 *
 * This software program is licensed subject to the GNU General Public License
 * (GPL).Version 2,June 1991, available at http://www.fsf.org/copyleft/gpl.html
 */

#ifndef __PXA3xx_PM_CHECK_H__
#define __PXA3xx_PM_CHECK_H__

struct gpio_check {
	int gpio;
	unsigned int mfp;
};

struct micco_check {
	unsigned char reg;
	unsigned char val;
};

int register_pxa3xx_mfp_setting(struct gpio_check (*mfp_setting)[]);
int register_pxa3xx_micco_setting(struct micco_check (*micco_setting)[]);

#if defined(CONFIG_CPU_PXA935)

#define CKENA_STANDBY		((0 << 31) 			|\
				 (1 << CKEN_MSL0) 		|\
				 (0 << CKEN_SSP4) 		|\
				 (0 << CKEN_SSP3) 		|\
				 (0 << CKEN_SSP2) 		|\
				 (0 << CKEN_SSP1) 		|\
				 (0 << 25) 			|\
				 (0 << CKEN_AC97) 		|\
				 (0 << CKEN_STUART) 		|\
				 (1 << CKEN_FFUART) 		|\
				 (0 << CKEN_BTUART) 		|\
				 (0 << CKEN_UDC) /* 1.1 only */	|\
				 (1 << 19) 			|\
				 (0 << 18) 			|\
				 (0 << CKEN_USIM0) 		|\
				 (0 << 16) 			|\
				 (0 << CKEN_CIR) 		|\
				 (1 << CKEN_KEYPAD) 		|\
				 (0 << CKEN_MMC2) 		|\
				 (0 << CKEN_MMC1) 		|\
				 (0 << CKEN_BOOT) 		|\
				 (1 << CKEN_ISC) 		|\
				 (0 << CKEN_SMC) 		|\
				 (1 << CKEN_DMC) 		|\
				 (1 << 7)			|\
				 (0 << 6) 			|\
				 (0 << 5) 			|\
				 (0 << CKEN_NAND) 		|\
				 (0 << CKEN_CAMERA) 		|\
				 (0 << 2) 			|\
				 (0 << CKEN_LCD) 		|\
				 (1 << 0))

#define CKENB_STANDBY		((1 << 31)			|\
				 (1 << 30)			|\
				 (1 << 29)			|\
				 (1 << 28)			|\
				 (1 << 27)			|\
				 (1 << 26)			|\
				 (1 << 25)			|\
				 (1 << 24)			|\
				 (1 << 23)			|\
				 (1 << 22)			|\
				 (1 << 21)			|\
				 (1 << 20)			|\
				 (1 << 19)			|\
				 (1 << 18)			|\
				 (0 << (CKEN_MINI_LCD % 32))	|\
				 (0 << (CKEN_MINI_IM % 32))	|\
				 (1 << 15)			|\
				 (1 << 14)			|\
				 (1 << 13)			|\
				 (1 << 12)			|\
				 (0 << 11)			|\
				 (0 << (CKEN_GCU_PXA300 % 32))	|\
				 (1 << 9)			|\
				 (0 << (CKEN_1WIRE % 32))	|\
				 (1 << (CKEN_GPIO % 32))	|\
				 (1 << 6)			|\
				 (0 << 5)			|\
				 (1 << (CKEN_I2C % 32))		|\
				 (0 << 3)			|\
				 (0 << 2)			|\
				 (0 << (CKEN_PWM1 % 32))	|\
				 (0 << (CKEN_PWM0 % 32)))

#define CKENC_STANDBY		((1 << 31)			|\
				 (1 << 30)			|\
				 (1 << 29)			|\
				 (1 << 28)			|\
				 (1 << 27)			|\
				 (1 << 26)			|\
				 (1 << 25)			|\
				 (1 << 24)			|\
				 (1 << 23)			|\
				 (1 << 22)			|\
				 (1 << 21)			|\
				 (1 << 20)			|\
				 (1 << (CKEN_AXI % 32))		|\
				 (1 << (CKEN_IMU_AXI % 32))	|\
				 (0 << 17)			|\
				 (0 << 16)			|\
				 (0 << 15)			|\
				 (0 << 14)			|\
				 (0 << 13)			|\
				 (0 << 12)			|\
				 (0 << 11)			|\
				 (0 << 10)			|\
				 (0 << 9)			|\
				 (0 << 8)			|\
				 (0 << 7)			|\
				 (0 << 6)			|\
				 (1 << 5)			|\
				 (0 << 4)			|\
				 (0 << 3)			|\
				 (0 << 2)			|\
				 (0 << 1)			|\
				 (1 << 0))

#elif defined(CONFIG_CPU_PXA930)

#define CKENA_STANDBY		((1 << 31) 			|\
				 (0 << CKEN_MSL0) 		|\
				 (0 << CKEN_SSP4) 		|\
				 (0 << CKEN_SSP3) 		|\
				 (0 << CKEN_SSP2) 		|\
				 (0 << CKEN_SSP1) 		|\
				 (1 << 25) 			|\
				 (0 << CKEN_AC97) 		|\
				 (0 << CKEN_STUART) 		|\
				 (1 << CKEN_FFUART) 		|\
				 (0 << CKEN_BTUART) 		|\
				 (0 << CKEN_UDC) 		|\
				 (0 << CKEN_TPM) 		|\
				 (0 << CKEN_USIM1) 		|\
				 (0 << CKEN_USIM0) 		|\
				 (1 << 16) 			|\
				 (0 << CKEN_CIR) 		|\
				 (1 << CKEN_KEYPAD) 		|\
				 (0 << CKEN_MMC2) 		|\
				 (0 << CKEN_MMC1) 		|\
				 (0 << CKEN_BOOT) 		|\
				 (1 << CKEN_ISC) 		|\
				 (0 << CKEN_SMC) 		|\
				 (1 << CKEN_DMC) 		|\
				 (0 << CKEN_GCU_PXA320)		|\
				 (0 << CKEN_USB2) 		|\
				 (1 << 5) 			|\
				 (0 << CKEN_NAND) 		|\
				 (0 << CKEN_CAMERA) 		|\
				 (0 << CKEN_USBH) 		|\
				 (0 << CKEN_LCD) 		|\
				 (1 << 0))

#define CKENB_STANDBY		((1 << 31)			|\
				 (1 << 30)			|\
				 (1 << 29)			|\
				 (1 << 28)			|\
				 (1 << 27)			|\
				 (1 << 26)			|\
				 (1 << 25)			|\
				 (1 << 24)			|\
				 (1 << 23)			|\
				 (1 << 22)			|\
				 (1 << 21)			|\
				 (1 << 20)			|\
				 (1 << 19)			|\
				 (1 << 18)			|\
				 (0 << (CKEN_MINI_LCD % 32))	|\
				 (0 << (CKEN_MINI_IM % 32))	|\
				 (1 << 15)			|\
				 (1 << 14)			|\
				 (1 << 13)			|\
				 (1 << 12)			|\
				 (1 << 11)			|\
				 (0 << (CKEN_GCU_PXA300 % 32))	|\
				 (1 << (CKEN_HSIO2 % 32))	|\
				 (0 << (CKEN_1WIRE % 32))	|\
				 (1 << (CKEN_GPIO % 32))	|\
				 (1 << 6)			|\
				 (1 << 5)			|\
				 (1 << (CKEN_I2C % 32))		|\
				 (1 << 3)			|\
				 (1 << 2)			|\
				 (0 << (CKEN_PWM1 % 32))	|\
				 (0 << (CKEN_PWM0 % 32)))

#endif

#endif /* __PXA3xx_PM_CHECK_H__ */
