/*
 * include/asm-arm/arch-pxa/t1021.h
 *
 * Touch panel header file.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * Copyright (C) 2008 Borqs Ltd.
 *
 */

#ifndef __ASM_ARCH_T1021_H
#define __ASM_ARCH_T1021_H

//===========================================================
// all register for clearpad: tm1204, tm1227, tm1219
// ===========================================================
// finger #0
#define REG_SMB_DATA_REG0	0x00
#define REG_SMB_DATA_REG1	0x01
#define REG_SMB_DATA_REG2	0x02
#define REG_SMB_DATA_REG3	0x03
#define REG_SMB_DATA_REG4	0x04
#define REG_SMB_DATA_REG5	0x05

// finger #1
#define REG_SMB_DATA_REG0_FINGER1	0x06
#define REG_SMB_DATA_REG1_FINGER1	0x07
#define REG_SMB_DATA_REG2_FINGER1	0x08
#define REG_SMB_DATA_REG3_FINGER1	0x09
#define REG_SMB_DATA_REG4_FINGER1	0x0A
#define REG_SMB_DATA_REG5_FINGER1	0x0B


#define REG_SMB_HORI_MOTION	0x0C
#define REG_SMB_VERT_MOTION	0x0D

#define REG_SMB_DEVICE_STATE	0x0E

#define REG_SMB_2D_CTRL		0x21
#define REG_SMB_SENSITIVITY	0x24
#define REG_SMB_MAX_POSH4	0x26
#define REG_SMB_MAX_POSL8	0x27

#define REG_SMB_RMI_VER		0xE0
#define REG_SMB_PID		0xE1
#define REG_SMB_INTERFACE_VER	0xE2
#define REG_SMB_PRODUCT_PROP	0xE3
#define REG_SMB_PRODUCT_INFO0	0xE4
#define REG_SMB_PRODUCT_INFO1	0xE5
#define REG_SMB_PRODUCT_INFO2	0xE6
#define REG_SMB_PRODUCT_INFO3	0xE7

#define REG_SMB_DEVICE_CTRL	0xF0
#define REG_SMB_INT_ENABLE	0xF1
#define REG_SMB_ERR_STATE	0xF2
#define REG_SMB_INT_STATE	0xF3
#define REG_SMB_RESET		0xF4
#define REG_SMB_PAGE_SELECT	0xFF

// ===========================================================
// data mask
// ===========================================================
#define SENSOR_STATE_WIDTH	0xF0
#define SENSOR_STATE_LOW4	0x0F
#define SENSOR_STATE_GESTURE	0x08
#define SENSOR_STATE_FINGER	0x07

#define CHIP_CONFIGURED		0X40

#define RESET			0x03
// ===========================================================
// power mode
// ===========================================================
#define ACTIVE_MODE		0x00
#define NORMAL_MODE		0x01
#define SLEEP_MODE		0x04
#define DEEP_SLEEP_MODE		0x06

struct t1021_platform_data {
	int	(*init_irq)(void);
	int	(*ack_irq)(void);
};

int cleartouch_chip_reset(void);
int cleartouch_chip_config(void);

int transform_xy_blaze(int *x, int *y);

#endif /* __ASM_ARCH_T1021_H */ 
