#ifndef _MMIS_CMD_LIST_V1_H_
#define _MMIS_CMD_LIST_V1_H_

//============IF101 v1====================
#define READ_MODE_SEL               0x01
#define READ_MODE_CONFIG            0x02

#define READ_DEMOD_STATUS           0x03	/* Reserved */

#define READ_INT_ENABLE				0x04	/* read MMIS_INT_MASK register */
#define WRITE_INT_ENABLE			0x05	/* write MMIS_INT_MASK register */
#define READ_INT_STATUS				0x06	/* read MMIS_INT_STATUS register */

#define READ_LG0_FILTER_PID_L		0x08
#define WRITE_LG0_FILTER_PID_L		0x09
#define READ_LG0_FILTER_PID_H		0x0a
#define WRITE_LG0_FILTER_PID_H		0x0b

#define READ_LG1_FILTER_PID_L		0x0c
#define WRITE_LG1_FILTER_PID_L		0x0d
#define READ_LG1_FILTER_PID_H		0x0e
#define WRITE_LG1_FILTER_PID_H		0x0f

#define READ_LG0_LEN_LOW			0x10
#define READ_LG0_LEN_MID			0x11
#define READ_LG0_LEN_HIGH			0x12

#define READ_LG1_LEN_LOW			0x13
#define READ_LG1_LEN_MID			0x14
#define READ_LG1_LEN_HIGH			0x15

#define FETCH_LG0_DATA				0x99
#define FETCH_LG1_DATA				0x9b

#define TX_ABORT					0x40	/* master break off transmitting */


// Register Bit Mask

// INT0_STATUS Bit Mask
#define LG0_DATA_RDY		(0x01)
#define LG1_DATA_RDY		(0x02)
#define TS0_DATA_RDY		(0x04)
#define LG0_ERR				(0x1u<<3)
#define LG1_ERR				(0x1u<<4)
#define TS0_ERR				(0x1u<<5)

#endif //_MMIS_CMD_LIST_V1_H_
