#ifndef __TS27010_MUX__
#define __TS27010_MUX__

#include "ringbuf.h"

#define NR_MUXS 16

#define NUM_MUX_CMD_FILES 16
#define NUM_MUX_DATA_FILES 0
#define NUM_MUX_FILES (NUM_MUX_CMD_FILES  +  NUM_MUX_DATA_FILES)


/* TODO: should use the IOCTLNUM macros */
/* Special ioctl() upon a MUX device file for hanging up a call */
#define TS0710MUX_IO_MSC_HANGUP 0x54F0

/* Special ioctl() upon a MUX device file for MUX loopback test */
#define TS0710MUX_IO_TEST_CMD 0x54F1
#define TS0710MUX_IO_MSC_AT  0x54F2
#define TS0710MUX_IO_MSC_DATA  0x54F3

/* TODO: get rid of these */
/* Special Error code might be return from write() to a MUX device file */
#define EDISCONNECTED 900	/* link is disconnected */

/* Special Error code might be return from open() to a MUX device file  */
#define EREJECTED 901		/* link connection request is rejected */

int ts27010_mux_active(void);
int ts27010_mux_line_open(int line);
void ts27010_mux_line_close(int line);
int ts27010_mux_line_write(int line, const unsigned char *buf, int count);
int ts27010_mux_line_chars_in_buffer(int line);
int ts27010_mux_line_write_room(int line);
int ts27010_mux_line_switch(int line, int cmd);

int ts27010_mux_send(unsigned char *buf, ssize_t len); /* callback */

#endif
