/*
 * mtp-io.h - MTP device library header
 *
 */



#include <linux/workqueue.h>
#ifndef _MTP_IO_H_
#define _MTP_IO_H_
#define MTP_EP0_SEND_MAX_SIZE 512
#define MTP_EP0_RECV_MAX_SIZE 512
/* mtpctl related */
#define MTP_CTL_CLASS_REQ    1
#define MTP_CTL_CLASS_REPLY  2

#define MTP_EXT_DESC_MAX_LEN    64
#define MTP_EXT_STR_MAX_LEN     32

struct mtp_ctl_msg_header 
{
    int msg_len;
    int msg_id;
} __attribute__ ((packed));

#define MTP_CTL_MSG_HEADER_SIZE   (sizeof(struct mtp_ctl_msg_header))

/* ioctl related */
#define MTP_EVENT_SIZE   28
struct mtp_event_data 
{
    unsigned char data[MTP_EVENT_SIZE];
} __attribute__ ((packed));

#define MTP_IOC_MAGIC    'm'
#define MTP_IOC_MAXNR    10

#define MTP_IOC_EVENT            _IOW(MTP_IOC_MAGIC, 1, struct mtp_event_data)
#define MTP_IOC_SEND_ZLP         _IO(MTP_IOC_MAGIC, 2)
#define MTP_IOC_GET_EP_PK_SIZE   _IOR(MTP_IOC_MAGIC, 3, int)
#define MTP_IOC_GET_VENDOR_FLAG  _IOR(MTP_IOC_MAGIC, 4, int)
#define MTP_IOC_CANCEL_IO        _IO(MTP_IOC_MAGIC, 5)
#define MTP_IOC_DEVICE_RESET     _IO(MTP_IOC_MAGIC, 6)


#endif  /* _MTP_IO_H_ */
