#ifndef _UDC_SYSFS_H_
#define _UDC_SYSFS_H_


struct udc_sysfs_data {
	unsigned char  mode;
	unsigned char  net_enum;
	unsigned char  testmode;
};

enum {
	NO_SWITCH	=	0X34,
	SWITCH_T0_ETHER, 
	SWITCH_TO_SERIAL_ACM,
	SWITCH_TO_SERIAL_NOACM,
	SWITCH_TO_MTP,
	MAX_SWITCH_COUNT,         

};

#ifdef CONFIG_SYSFS

extern int  udc_sysfs_register(struct device *dev,char *name);
extern void udc_sysfs_unregister(void);
extern void udc_kobject_uevent(	struct udc_sysfs_data *data, 
				enum kobject_action action,bool uevent);
#else

static inline int udc_sysfs_register(struct device *dev)
{ return 0; }
static void udc_sysfs_unregister(void) {}
#define udc_kobject_uevent NULL

#endif /* CONFIG_SYSFS */

#endif
