/*
 * include/linux/bq2407x_charger.h
 *
 * Copyright © 2009 Ru Yi <yi.ru@borqs.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __BQ2407x_CHARGER_H__
#define __BQ2407x_CHARGER_H__

/* return value for detect() */
enum {
	BQ2407x_POWER_NO_CHARGER = 0,
	BQ2407x_POWER_CHARGE_AC,
	BQ2407x_POWER_CHARGE_USB,
};

/* parameters for set_charge() */
enum {
	BQ2407x_POWER_DISABLE = 0,
	BQ2407x_POWER_ENABLE,
};

/* parameters for set_current() */
enum  {
        CHARGING_SUSPEND = 0,
        CHARGING_CURRENT_100,
        CHARGING_CURRENT_500,
        CHARGING_CURRENT_FULL,
};

struct bq2407x_charger_pdata {
	int (*init)(void);
	int (*detect)(void);
	int (*is_charging)(void);
	int (*is_cable_on)(void);
	void (*set_charge)(int enable);
	void (*set_current)(int current_type);
	void (*exit)(void);
	int irq;
	int det_irq;

	char **supplied_to;
	size_t num_supplicants;

	unsigned int wait_for_status;	/* msecs, default is 500 */
	unsigned int wait_for_charger;	/* msecs, default is 500 */
};

#endif /* __BQ2407x_CHARGER_H__ */
