#ifndef __IPC_DPRAM__
#define __IPC_DPRAM__

/* processor state */
enum state_type {
	NOT_READY = 0,
	READY,
};

enum config_ipc_cmd {
	GET_BP_READY,
	RESET_BP,
	SET_AP_READY,
	SET_AP_NOT_READY,
	SET_AP_SLEEP,
	SET_AP_RESUME,
	GET_MAILBOX_STATE,
	POWERON_BP,
	SHUTDOWN_BP,
};
typedef	enum state_type (*config_ipc_func)(enum config_ipc_cmd cmd);

struct dpram_platform_data {
	unsigned int bp_wd_out_irq;
	unsigned int bp_rdy_irq;
	unsigned int mailbox_irq;
	u16 *ram_addr;
	config_ipc_func config_ipc;
};

#endif
