/* include/linux/latesuspend.h
 *
 * Copyright (C) 2007-2008 Google, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _LINUX_LATESUSPEND_H
#define _LINUX_LATESUSPEND_H

#ifdef CONFIG_HAS_LATESUSPEND
#include <linux/list.h>
#endif

struct late_suspend {
	struct list_head link;
	int level;
	void (*suspend)(struct late_suspend *h);
	void (*resume)(struct late_suspend *h);
};

#ifdef CONFIG_HAS_LATESUSPEND
void register_late_suspend(struct late_suspend *handler);
void unregister_late_suspend(struct late_suspend *handler);
int pm_late_suspend(void);
#else
#define register_late_suspend(handler) do { } while (0)
#define unregister_late_suspend(handler) do { } while (0)
#define pm_late_suspend() do { } while (0)
#endif

#endif

