/* 
 * include/linux/modem.h
 *
 * Support for modem device.
 *
 * Copyright (C) 2009 Borqs, Inc.
 * Author: Emichael Li <emichael.li@borqs.com>
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _MODEM_H
#define _MODEM_H

enum modem_power_state {
	MPS_OFF = 0,
	MPS_BOOTING,
	MPS_ON,
};

struct modem_platform_data {
	int (*set_power_state) (enum modem_power_state state);
	int (*ap_rts) (int rts);
	int (*ap_rdy) (int rdy);
	int (*ap_wakeup) (int wk_up);
	int (*ap_sleep) (int sleep);

	int (*bp_rts) (void);
	int (*bp_rdy) (void);
	int (*bp_wakeup) (void);
	int (*bp_sleep) (void);
	int (*bp_life) (void);

	int bp_rts_irq;
	int bp_rdy_irq;
	int bp_wakeup_irq;
	int bp_sleep_irq;
	int bp_life_irq;

	unsigned long private_data;
};
#endif
