/*
 *  USBUART Switch driver
 *
 * Copyright (C) 2009 BORQS, Inc.
 * Author: Emichael Li <emichael.li@borqs.com>
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
*/

#ifndef __LINUX_USBUART_SWITCH_H__
#define __LINUX_USBUART_SWITCH_H__

enum usbuart_event {
	USBUART_AGPS = (1U << 0),
	USBUART_USB = (1U << 1),
	USBUART_DBG = (1U << 2),
};

#ifdef CONFIG_SWITCH_USBUART

enum usbuart_state {
	USBUART_AP_UART = 0,
	USBUART_AP_USB = 1,
};

struct usbuart_switch_platform_data {
	const char *name;
	int (*set_state) (enum usbuart_event event, int on);
	enum usbuart_state (*get_state) (void);
};

extern int usbuart_set_state(enum usbuart_event event, int on);

#else

static inline int usbuart_set_state(enum usbuart_event event, int on)
{
	return 0;
}

#endif

#endif /* __LINUX_SWITCH_H__ */
