/*
 * include/linux/synaptics_i2c_rmi.h - platform data structure for f75375s sensor
 *
 * Copyright (C) 2008 Google, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _LINUX_SYNAPTICS_I2C_RMI_H
#define _LINUX_SYNAPTICS_I2C_RMI_H

#define SYNAPTICS_I2C_RMI_NAME "synaptics-rmi-ts"

struct synaptics_key {
	uint8_t channel;
	int code;
	int start_position;
	int end_position;
};

struct synaptics_key_array {
	struct synaptics_key *keys;
	int num_keys;
};

struct synaptics_i2c_rmi_platform_data {
	int (*power)(int on);	/* Only valid in first array entry */

	unsigned long irqflags;

	uint32_t abs_min_x;
	uint32_t abs_max_x;
	uint32_t abs_min_y;
	uint32_t abs_max_y;
	uint32_t abs_min_p;
	uint32_t abs_max_p;
	uint32_t abs_min_w;
	uint32_t abs_max_w;

	uint32_t fuzz_x;
	uint32_t fuzz_y;
	uint32_t fuzz_p;
	uint32_t fuzz_w;

	uint32_t keys_min_y;
	uint32_t keys_max_y;

	int8_t touch_sensitivity;

	struct synaptics_key_array key_array;
};

#endif /* _LINUX_SYNAPTICS_I2C_RMI_H */
