#!/usr/bin/perl
#
# checkincludes: Find files included more than once in (other) files.
# Copyright abandoned, 2000, Niels Kristian Bech Jensen <nkbj@image.dk>.

$deep = 0;
$includedallfiles = ();
$pathname = "";

sub basename($) 
{
	my $file = shift;
	$file =~ s!^(?:.*/)?(.+?)(?:\.[^.]*)?$!$1!;
	return $file;
}  

sub dirname($) 
{
	my $file = shift;
	$file =~ s!/?[^/]*/*$!!; 
	return $file;
}


sub searchinclude 
{
	my $filen = "@_";
	my $sum = 0;
	my $ret = 0;
	my $inc_filename = "include/$filen";
	my $dir_filename = "$pathname/$filen";

	if (++$deep == 5) {
		--$deep;
		return;
	}

	$ret = open(FILE, $filen);
	if ($ret != 1) {
		$ret = open(FILE, $inc_filename);
		if ($ret != 1) {
			$ret = open(FILE, $dir_filename);
			if ($ret != 1) {
				--$deep;
				return ;
			}
		}
	}

	my %includedfiles = ();

	while (<FILE>) {
		if (m/^\s*#\s*include\s*[<"](\S*)[>"]/o) {
			++$includedfiles{$1};
			++$includedallfiles{$1};
			++$sum;
		}
	}

	foreach $filename (keys %includedfiles) { 
		searchinclude($filename);
	}	

	close(FILE);
	--$deep;
}

foreach $file (@ARGV) {
	$pathname = dirname($file);
	searchinclude($file);
	foreach $filename (keys %includedallfiles) {
		print "$filename\n";
	}
}
