#! /bin/sh
# 
#================================================================================
#                                                                               
# Module Name:  setup.sh
#
# General Description: setup configuration for dedicated product
#
#================================================================================
#
#  Copyright (C) 2007-2010 Borqs Inc.
# 
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License version 2 as published
#  by the Free Software Foundation.
#

usage_help() {
    echo "usage:  ./setup.sh [PRODUCT=<product_name>] [root=ramdisk|qemu] formal_release"
    echo "param:  <product_name>"
    echo "    PRODUCT=GOLDFISH_DRAGON   (GOLDFISH)"
    echo "    PRODUCT=SAAR              (SAAR)"
    echo "    PRODUCT=BENZINA_DRAGON    (BENZINA)"
    echo "    PRODUCT=BENZ2GWIFI_DRAGON (BENZINA GSM with WIFI)"
    echo "    PRODUCT=BENZGLB_DRAGON    (BENZINA Global)"
    echo "    PRODUCT=BENZGLB512_DRAGON (BENZINA Global 512M DDR)"
    echo "    PRODUCT=BLAZE_DRAGON      (BLAZE)"
    echo "    PRODUCT=BEACON            (BEACON)"
    echo "    PRODUCT=T8200             (T8200)"
    echo "    PRODUCT=BENZINA2          (BENZINA2)"
    echo "    PRODUCT=IGNITE            (IGNITE)"
    echo "    PRODUCT=MG1_JIL           (MG1_JIL)"
    echo "    ?                         (print this help)"
}

case "$1" in
    PRODUCT=GOLDFISH_DRAGON)
        make goldfish_defconfig
        ;;
    PRODUCT=SAAR)
        make pxa935_defconfig
        ;;
    PRODUCT=BENZINA_DRAGON)
	make benzina_defconfig
        ;;
    PRODUCT=BENZ2GWIFI_DRAGON)
	make benzina_defconfig
        ;;
    PRODUCT=BENZGLB_DRAGON)
	make benzglb_defconfig
        ;;
    PRODUCT=BENZGLB512_DRAGON)
	make benzglb_512_defconfig
        ;;
    PRODUCT=BLAZE_DRAGON)
	make blaze_defconfig
	;;
    PRODUCT=BEACON)
	make beacon_defconfig
	;;
    PRODUCT=T8200)
	make t8200_defconfig
	;;
    PRODUCT=BENZINA2)
	make benzina2_defconfig
	;;
     PRODUCT=IGNITE)
	make ignite_defconfig
	;;
     PRODUCT=MG1_JIL)
	make bigbrother_mg1_defconfig
	;;
    *)
	usage_help
        exit 1
        ;;
esac


case "$2" in
    root=ramdisk)
	;;
    root=qemu)
	;;
    *)
	usage_help
	exit 1
	;;
esac

case "$3" in
    formal_release)
    	;;
esac

echo "Please run make zImage\n"
